// 图标上显示Badge
// chrome.browserAction.setBadgeText({text: 'cirle'});
// chrome.browserAction.setBadgeBackgroundColor({color: [255, 0, 0, 255]});

// 点击图标, 弹出popup
chrome.browserAction.setPopup({popup:'src/popup/popup.html'});

// 点击图标, 打开页面或者加载content_script(js/css)到web页面
// chrome.browserAction.onClicked.addListener(function(tab) {
//   // 打开页面 参考 src-master-chrome-common-extensions-docs-examples-api-cookies
//   // var manager_url = chrome.extension.getURL("manager.html");
//   // focusOrCreateTab(manager_url);
//
//   // 加载content-script到web页面
//   chrome.tabs.executeScript(null, {
//     file: 'src/content.js'
//   });
// });

//跨域拿所有cookie
// chrome.cookies.getAll({domain:'.growingio.com'}, function(cookies) {
//   for (var i in cookies) {
//     if (cookies[i].domain=='.growingio.com'){
//       console.log(JSON.stringify(cookies[i]));
//     }
//   }
// });

// 各个tab的内存级别变量，每次新打开chrome都会清空
var contentLoadedTabs=[];
var circleStatusTabs={};


function fetchSuccess(response) {
  if (response.status !== 200) {
    console.log('Looks like there was a problem. Status Code: ' + response.status);
    return;
  }

  response.json().then(function(data) {
    console.log('fetch hosts:',data);
  });
}

function fetchError(error) {
  console.log('Request failed', error);
}

function messageHandler(message, sender, callback){
  var messageFrom = sender.tab ? sender.tab.url : 'extension';
  // console.log({'message':message,'from':messageFrom,'sender':sender});
  callbackGlobal = callback;
  switch (message.type){
    case 'getCookie':
      chrome.cookies.get({ url: 'http://www.growingio.com', name: message.content },
        function (cookie) {
          var value  =  cookie? cookie.value:"";
          console.log('value=',value);
          callback(cookie);
        });
      // callback如果是异步返回，必须return true;
      return true;
      break;
    case 'isContentLoaded':
      var contentLoaded = getContentLoaded(sender.tab.id);
      callback({contentLoaded});
      if (!contentLoaded){
        contentLoadedTabs.push(sender.tab.id);
      }
      break;
    case 'getUsers':
      fetch(message.endpoint, message.init)
        .then(function(response) {
          if (response.status !== 200) {
            console.log('Looks like there was a problem. Status Code: ' +
              response.status);
            if (response.status === 400) {
              sendMessageToContentScript({type: 'userTokenExpire'});
            }
            return;
          }
          return response.json()
        })
        .then(function(data) {
          callback(data);
        })
        .catch(function (error) {
          console.log('fetch getUsers Request failed', error);
        });
      return true;
      break;
    case 'getPermission':
      fetch(message.endpoint, message.init)
        .then(function(response) {
          if (response.status !== 200) {
            console.log('Looks like there was a problem. Status Code: ' +
              response.status);
            if (response.status === 400) {
              sendMessageToContentScript({type: 'userTokenExpire'});
            }
            return;
          }
          return response.json()
        })
        .then(function(data) {
          callback(data);
        })
        .catch(function (error) {
          console.log('fetch getPermission Request failed', error);
        });
      return true;
      break;
    case 'getProduct':
      fetch(message.endpoint, message.init)
        .then(function(response) {
          if (response.status !== 200) {
            console.log('Looks like there was a problem. Status Code: ' +
              response.status);
            if (response.status === 400) {
              sendMessageToContentScript({type: 'userTokenExpire'});
            }
            return;
          }
          return response.json()
        })
        .then(function(data) {
          callback(data);
        })
        .catch(function (error) {
          console.log('fetch getProduct Request failed', error);
        });
      return true;
      break;
    case 'fetchAllTags':
      fetch(message.endpoint, message.init)
        .then(function(response) {
          if (response.status !== 200) {
            console.log('Looks like there was a problem. Status Code: ' +
              response.status);
            if (response.status === 400) {
              sendMessageToContentScript({type: 'userTokenExpire'});
            }
            if (response.status == 500) {
              sendMessageToContentScript({type: 'authError'});
            }
            return;
          }
          return response.json()
        })
        .then(function(data) {
          callback(data);
        })
        .catch(function (error) {
          console.log('fetchAllTags Request failed', error);
        });
      return true;
      break;
    case 'fetchPatterns':
      fetch(message.endpoint, message.init)
        .then(function(response) {
          if (response.status !== 200) {
            console.log('Looks like there was a problem. Status Code: ' +
              response.status);
            return;
          }
          return response.json()
        })
        .then(function(data) {
          callback(data);
        })
        .catch(function (error) {
          console.log('fetchPatterns Request failed', error);
        });
      return true;
      break;
    case 'fetchData':
      fetch(message.endpoint, message.init)
        .then(function(response) {
          if (response.status !== 200) {
            console.log('Looks like there was a problem. Status Code: ' +
              response.status);
            return;
          }
          return response.json()
        })
        .then(function(data) {
          callback(data);
        })
        .catch(function (error) {
          console.log('fetchData Request failed', error);
        });
      return true;
      break;
    case 'saveTag':
      fetch(message.endpoint, message.init)
        .then(function(response) {
          return response.json()
        })
        .then(function(data) {
          callback(data);
        })
        .catch(function (error) {
          console.log('saveTag Request failed', error);
        });
      return true;
      break;
    case 'checkElement':
      // 这个新的指标体系我醉了，创建了一个元素后，竟然还要前端查一下action是啥。
      fetch(message.endpoint, message.init)
        .then(function(response) {
          if (response.status !== 200) {
            console.log('Looks like there was a problem. Status Code: ' +
              response.status);
            return;
          }
          return response.json()
        })
        .then(function(data) {
          callback(data);
        })
        .catch(function (error) {
          console.log('saveTag Request failed', error);
        });
      return true;
      break;
    default:

  }
}


function getContentLoaded(tabId){
  return contentLoadedTabs.includes(tabId);
}

function getCircleStatus(tabId){
  if(!circleStatusTabs[tabId]){
    // 用户级别,刷新不清除的状态 退出必须清除
    circleStatusTabs[tabId]={gio_projectId:null,gio_permission:null};
    resetCircleStatus(tabId);
  }
  return circleStatusTabs[tabId];
}

function setCircleStatus(tabId,k,v){
  circleStatusTabs[tabId][k]=v;
  return true;
}

function resetCircleStatus(tabId){
  // 页面级别，刷新清除的状态
  circleStatusTabs[tabId]['gio_mode']='browse-mode';
  circleStatusTabs[tabId]['gio_highlight']='eye-on';
}

chrome.runtime.onMessage.addListener(messageHandler);


chrome.tabs.onUpdated.addListener(function(tabId, changeInfo, tab){

  if(changeInfo.status == "complete"){
    // 每次页面刷新 或者加载了新页面 都需要删除原来的标志 保证第一次圈选的时候，重新执行content
    var index = contentLoadedTabs.indexOf(tabId);
    if (index > -1) {
      contentLoadedTabs.splice(index, 1);
      resetCircleStatus(tabId);
    }
  }
});

function sendMessageToContentScript(message, callback)
{
  chrome.tabs.query({active: true, currentWindow: true}, function(tabs)
  {
    chrome.tabs.sendMessage(tabs[0].id, message, function(response)
    {
      if(callback) callback(response);
    });
  });
}


